Subject: Re: bug#51621: 29.0.50; bibtex.el biblatex "2.1.3 Non-standard Types" support

From: Leo Stein <[email-masked]>
Date: Tue, 3 Dec 2024 15:12:43 -0600

On Tue, Dec 3, 2024 at 2:37 PM Roland Winkler <[email-masked]> wrote:

> On Mon, Dec 02 2024, Leo Stein wrote:
> > I really wish this was more permissive. Looking at a .bib file, we
> > have no way of knowing the biblio style that it's going to be set
> > with. We also have no way of knowing whether the user is going to
> > parse it with bibtex or biber.
>
> The user needs to know whether she wants to use a bib file with BibTeX
> or biblatex and use entry types these programs can handle.  Bibtex-mode
> cannot be blamed for this.
>

We are both re-hashing the same points. I will say again that both bibtex
and biber+biblatex can handle any types of entries. I think the more
flexible approach is to permissive about entry types, and allow
bibtex-parse-entry to parse an entry of any type, not just a fixed list of
default types from (i) btxdoc.pdf, a piece of documentation from 1988; and
(ii) biblatex.pdf, the documentation for a latex package, not the parser,
biber, which indeed allows any entry type.

>
> > I am still missing something... as far as I can tell, the "dialect" is
> > just controlling which entries are valid. Is that right? But this is
> > not within the purview of whether we use bibtex, or biber+biblatex. It
> > depends on the biblio style that the user wants to use for setting
> > their bibliography.
>
> Beyond the defaults documented for BibTeX and biblatex, you are free to
> write your own bst style files, and you are free to customize
> bibtex-mode to your liking.  Everything we discuss here refers only to
> user options of bibtex-mode.
>
> The defaults of bibtex-mode match the defaults specified in the
> documentation of BibTeX and biblatex.  It would be confusing for users
> of bibtex-mode to deviate from that.
>

You don't understand why you say it would be confusing. Just like emacs can
not read users' minds, I don't see how you can be sure about what would be
confusing. There are common entry types, e.g. @software, which are in very
wide use with standard bibtex.

>
> > I'm happy to hear that there will be future improvements.
>
> The goal is to facilitate the customization of bibtex-mode.  I see no
> reason to change the defaults of user variables.
>
> > I sincerely request that parsing of entries be made more permissive —
> > not restricted to a list of entry types, or relying on the user to
> > make some customizations [I think most users are not going to discover
> > that it's possible to customize this].
>
> It is a basic aspect of Emacs that users can customize its behavior.
> But Emacs cannot (yet) read the mind of its users and foresee the
> customizations they want.
>
> I have heard rumors that reading the users' mind will become a user
> option in Emacs 42.  (But I do not know whether this option will be
> enabled by default.)
>

You don't have to try to read my mind — I am trying to make my mind known
to the devs by emailing this list. I continue to strongly request
that bibtex-parse-entry should be more permissive about parsing types than
a predefined list from 1988.